<?php
namespace Teknisa\SM\Factory;

use Doctrine\ORM\EntityManager;

class Sm00035000MaximoCarenciaPropostaPerfilAcessoFactory
{
    
    protected $connection;
    
    public function __construct(EntityManager $entityManager) {
        
        $this->connection = $entityManager->getConnection();
    }
    
     /**
     * A função "validaCarenciaOperador" verifica se já existe 
     * uma carencia cadastrada para o operador indicado.
     */
     
    public function validaCarenciaPerfilAcesso($params){
        
        $queryValidaCarenciaPerfProp = "SELECT COUNT(*) AS VALIDAPERF
                                      FROM FCT_CARENCIAPERFIL
                                     WHERE NRPERFILACESSO = :NRPERFILACESSO
                                       AND NRORG = :NRORG";

        $std = $this->connection->prepare($queryValidaCarenciaPerfProp);
        $std->execute($params);
        $returnValidaCarenciaPerfProp = $std->fetchAll();
        return $returnValidaCarenciaPerfProp;
    }
    
    public function validarInsercaoFaixaDescontoPerfil($params){
        $query = "SELECT  NVL( COUNT(fai.NRPARCELASMAX),  0) AS QUANTIDADE FROM FCT_CARENCIAFAIXADESC fai WHERE  fai.NRCARENCIAPERFIL = :NRPERFILACESSO";
        $std = $this->connection->prepare($query);
        $std->execute($params);
        return $std->fetchAll();
    } 
    
    public function validarInsercaoFaixaDescontoOperador($params){
        $query = "SELECT  NVL( COUNT(fai.NRPARCELASMAX),  0) AS QUANTIDADE FROM FCT_CARENCIAFAIXADESC fai WHERE  fai.NRCARENCIAOPER = :NRPARCNEGOCIO";
        $std = $this->connection->prepare($query);
        $std->execute($params);
        return $std->fetchAll();
    }
    
    public function inserirFaixaDesconto($params){
        $query = " INSERT INTO FCT_CARENCIAFAIXADESC   (NRCARENCIAFAIXADESC, NRCARENCIAPERFIL, NRCARENCIAOPER, NRPARCELASMAX, VRPERCDESCDE, VRPERCDESCATE, NRORG, NRORGINCLUSAO, CDOPERADOR, CDOPERINCLUSAO, DTINCLUSAO) VALUES (:NRCARENCIAFAIXADESC, :NRCARENCIAPERFIL, :NRCARENCIAOPER, :NRPARCELASMAX, :VRPERCDESCDE, :VRPERCDESCATE, :NRORG, :NRORGINCLUSAO, :CDOPERADOR, :CDOPERINCLUSAO, SYSDATE)";
        $std = $this->connection->prepare($query);
        $std->execute($params);
    }
    
    public function atualizaFaixaDesconto($params){
        $query = "UPDATE FCT_CARENCIAFAIXADESC SET NRCARENCIAPERFIL = :NRCARENCIAPERFIL, NRCARENCIAOPER = :NRCARENCIAOPER, NRPARCELASMAX = :NRPARCELASMAX, VRPERCDESCDE = :VRPERCDESCDE, VRPERCDESCATE = :VRPERCDESCATE, NRORG = :NRORG, CDOPERADOR = :CDOPERADOR, CDOPERULTATU = :CDOPERULTATU, NRORGULTATU = :NRORGULTATU, DTULTATU = SYSDATE WHERE NRCARENCIAFAIXADESC = :NRCARENCIAFAIXADESC";
        $std = $this->connection->prepare($query);
        $std->execute($params);
    }
    
    public function pegarBetweenCarenciaOperador($params){
        $query = "SELECT COUNT(*) AS EXISTE FROM FCT_CARENCIAFAIXADESC WHERE NRCARENCIAOPER = :NRCARENCIAOPER AND (:VRINI BETWEEN VRPERCDESCDE AND VRPERCDESCATE OR :VRFIN BETWEEN VRPERCDESCDE AND VRPERCDESCATE)";
        $std = $this->connection->prepare($query);
        $std->execute($params);
        return $std->fetchAll();
    }
    
    public function pegarBetweenCarenciaPerfil($params){
        $query = "SELECT COUNT(*) AS EXISTE FROM FCT_CARENCIAFAIXADESC WHERE NRCARENCIAPERFIL = :NRPERFILACESSO AND (:VRINI BETWEEN VRPERCDESCDE AND VRPERCDESCATE OR :VRFIN BETWEEN VRPERCDESCDE AND VRPERCDESCATE)";
        $std = $this->connection->prepare($query);
        $std->execute($params);
        return $std->fetchAll();
    }

}

?>